]> git.notmuchmail.org Git - notmuch/blobdiff - test/test-lib.sh
Fix handling of broken tests.
[notmuch] / test / test-lib.sh
old mode 100644 (file)
new mode 100755 (executable)
index d045820..da91de8
 # You should have received a copy of the GNU General Public License
 # along with this program.  If not, see http://www.gnu.org/licenses/ .
 
+if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
+    echo "Error: The notmuch test suite requires a bash version >= 4.0"
+    echo "due to use of associative arrays within the test suite."
+    echo "Please try again with a newer bash (or help us fix the"
+    echo "test suite to be more portable). Thanks."
+    exit 1
+fi
+
 # if --tee was passed, write the output not only to the terminal, but
 # additionally to the file test-results/$BASENAME.out, too.
 case "$GIT_TEST_TEE_STARTED, $* " in
@@ -49,15 +57,6 @@ unset CDPATH
 
 unset GREP_OPTIONS
 
-case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
-       1|2|true)
-               echo "* warning: Some tests will not work if GIT_TRACE" \
-                       "is set as to trace on STDERR ! *"
-               echo "* warning: Please set GIT_TRACE to something" \
-                       "other than 1, 2 or true ! *"
-               ;;
-esac
-
 # Convenience
 #
 # A regexp to match 5 and 40 hexdigits
@@ -130,21 +129,22 @@ if test -n "$color"; then
                        *) test -n "$quiet" && return;;
                esac
                shift
-               printf "* %s" "$*"
+               printf " "
+                printf "$@"
                tput sgr0
-               echo
                )
        }
 else
        say_color() {
                test -z "$1" && test -n "$quiet" && return
                shift
-               echo "* $*"
+               printf " "
+                printf "$@"
        }
 fi
 
 error () {
-       say_color error "error: $*"
+       say_color error "error: $*\n"
        GIT_EXIT_OK=t
        exit 1
 }
@@ -158,17 +158,13 @@ error "Test script did not set test_description."
 
 if test "$help" = "t"
 then
-       echo "$test_description"
+       echo "Tests ${test_description}"
        exit 0
 fi
 
+echo $(basename "$0"): "Testing ${test_description}"
+
 exec 5>&1
-if test "$verbose" = "t"
-then
-       exec 4>&2 3>&1
-else
-       exec 4>/dev/null 3>/dev/null
-fi
 
 test_failure=0
 test_count=0
@@ -243,6 +239,12 @@ increment_mtime ()
 #      Generate the message in directory 'directory/of/choice' within
 #      the mail store. The directory will be created if necessary.
 #
+#  [filename]=name
+#
+#      Store the message in file 'name'. The default is to store it
+#      in 'msg-<count>', where <count> is three-digit number of the
+#      message.
+#      
 #  [body]=text
 #
 #      Text to use as the body of the email message
@@ -279,10 +281,14 @@ generate_message ()
     local additional_headers
 
     gen_msg_cnt=$((gen_msg_cnt + 1))
-    gen_msg_name=msg-$(printf "%03d" $gen_msg_cnt)
+    if [ -z "${template[filename]}" ]; then
+       gen_msg_name="msg-$(printf "%03d" $gen_msg_cnt)"
+    else
+       gen_msg_name=${template[filename]}
+    fi
 
     if [ -z "${template[id]}" ]; then
-       gen_msg_id="${gen_msg_name}@notmuch-test-suite"
+       gen_msg_id="${gen_msg_name%:2,*}@notmuch-test-suite"
     else
        gen_msg_id="${template[id]}"
     fi
@@ -311,7 +317,7 @@ generate_message ()
     fi
 
     if [ -z "${template[date]}" ]; then
-       template[date]="Tue, 05 Jan 2001 15:43:57 -0800"
+       template[date]="Tue, 05 Jan 2001 15:43:57 -0000"
     fi
 
     additional_headers=""
@@ -360,7 +366,7 @@ EOF
     increment_mtime "$(dirname "${gen_msg_filename}")"
 }
 
-# Generate a new message and add it to the index.
+# Generate a new message and add it to the database.
 #
 # All of the arguments and return values supported by generate_message
 # are also supported here, so see that function for details.
@@ -370,26 +376,87 @@ add_message ()
     notmuch new > /dev/null
 }
 
-pass_if_equal ()
+# Generate a corpus of email and add it to the database.
+#
+# This corpus is fixed, (it happens to be 50 messages from early in
+# the history of the notmuch mailing list), which allows for reliably
+# testing commands that need to operate on a not-totally-trivial
+# number of messages.
+add_email_corpus ()
 {
-    output=$1
-    expected=$2
-
-    if [ "$output" = "$expected" ]; then
-       true
+    rm -rf ${MAIL_DIR}
+    if [ -d ../corpus.mail ]; then
+       cp -a ../corpus.mail ${MAIL_DIR}
     else
-       testname=$this_test.$test_count
-       echo "$expected" > $testname.expected
-       echo "$output" > $testname.output
-       diff -u $testname.expected $testname.output
-       false
+       cp -a ../corpus ${MAIL_DIR}
+       notmuch new >/dev/null
+       cp -a ${MAIL_DIR} ../corpus.mail
     fi
 }
 
-TEST_DIR=$(pwd)/test.$$
-MAIL_DIR=${TEST_DIR}/mail
-export NOTMUCH_CONFIG=${TEST_DIR}/notmuch-config
-NOTMUCH=notmuch
+test_begin_subtest ()
+{
+    if [ -n "$inside_subtest" ]; then
+       exec 1>&6 2>&7          # Restore stdout and stderr
+       error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
+    fi
+    test_subtest_name="$1"
+    # Remember stdout and stderr file descriptios and redirect test
+    # output to the previously prepared file descriptors 3 and 4 (see
+    # bellow)
+    if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
+    exec 6>&1 7>&2 >&3 2>&4
+    inside_subtest=t
+}
+
+# Pass test if two arguments match
+#
+# Note: Unlike all other test_expect_* functions, this function does
+# not accept a test name. Instead, the caller should call
+# test_begin_subtest before calling this function in order to set the
+# name.
+test_expect_equal ()
+{
+       exec 1>&6 2>&7          # Restore stdout and stderr
+       inside_subtest=
+       test "$#" = 3 && { prereq=$1; shift; } || prereq=
+       test "$#" = 2 ||
+       error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
+
+       output="$1"
+       expected="$2"
+       if ! test_skip "$@"
+       then
+               if [ "$output" = "$expected" ]; then
+                       test_ok_ "$test_subtest_name"
+               else
+                       testname=$this_test.$test_count
+                       echo "$expected" > $testname.expected
+                       echo "$output" > $testname.output
+                       test_failure_ "$test_subtest_name" "$(diff -u $testname.expected $testname.output)"
+               fi
+    fi
+}
+
+test_expect_equal_failure ()
+{
+       exec 1>&6 2>&7          # Restore stdout and stderr
+       inside_subtest=
+       test "$#" = 3 && { prereq=$1; shift; } || prereq=
+       test "$#" = 2 ||
+       error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
+
+       output="$1"
+       expected="$2"
+       if ! test_skip "$@"
+       then
+               if [ "$output" = "$expected" ]; then
+                       test_known_broken_ok_ "$test_subtest_name"
+               else
+                       test_known_broken_failure_ "$test_subtest_name"
+               fi
+    fi
+}
 
 NOTMUCH_NEW ()
 {
@@ -439,25 +506,30 @@ test_have_prereq () {
 
 test_ok_ () {
        test_success=$(($test_success + 1))
-       say_color "" "  ok $test_count: $@"
+       say_color pass "%-6s" "PASS"
+       echo " $@"
 }
 
 test_failure_ () {
        test_failure=$(($test_failure + 1))
-       say_color error "FAIL $test_count: $1"
+       say_color error "%-6s" "FAIL"
+       echo " $1"
        shift
        echo "$@" | sed -e 's/^/        /'
+       if test "$verbose" != "t"; then cat test.output; fi
        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 }
 
 test_known_broken_ok_ () {
        test_fixed=$(($test_fixed+1))
-       say_color "" "  FIXED $test_count: $@"
+       say_color pass "%-6s" "FIXED"
+       echo " $@"
 }
 
 test_known_broken_failure_ () {
        test_broken=$(($test_broken+1))
-       say_color skip "  still broken $test_count: $@"
+       say_color pass "%-6s" "BROKEN"
+       echo " $@"
 }
 
 test_debug () {
@@ -466,6 +538,7 @@ test_debug () {
 
 test_run_ () {
        test_cleanup=:
+       if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
        eval >&3 2>&4 "$1"
        eval_ret=$?
        eval >&3 2>&4 "$test_cleanup"
@@ -475,7 +548,7 @@ test_run_ () {
 test_skip () {
        test_count=$(($test_count+1))
        to_skip=
-       for skp in $GIT_SKIP_TESTS
+       for skp in $NOTMUCH_SKIP_TESTS
        do
                case $this_test.$test_count in
                $skp)
@@ -490,7 +563,8 @@ test_skip () {
        case "$to_skip" in
        t)
                say_color skip >&3 "skipping test: $@"
-               say_color skip "skip $test_count: $1"
+               say_color skip "%-6s" "SKIP"
+               echo " $1"
                : true
                ;;
        *)
@@ -505,7 +579,6 @@ test_expect_failure () {
        error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
        if ! test_skip "$@"
        then
-               say >&3 "checking known breakage: $2"
                test_run_ "$2"
                if [ "$?" = 0 -a "$eval_ret" = 0 ]
                then
@@ -514,7 +587,6 @@ test_expect_failure () {
                        test_known_broken_failure_ "$1"
                fi
        fi
-       echo >&3 ""
 }
 
 test_expect_success () {
@@ -523,7 +595,6 @@ test_expect_success () {
        error "bug in the test script: not 2 or 3 parameters to test-expect-success"
        if ! test_skip "$@"
        then
-               say >&3 "expecting success: $2"
                test_run_ "$2"
                if [ "$?" = 0 -a "$eval_ret" = 0 ]
                then
@@ -532,7 +603,6 @@ test_expect_success () {
                        test_failure_ "$@"
                fi
        fi
-       echo >&3 ""
 }
 
 test_expect_code () {
@@ -541,7 +611,6 @@ test_expect_code () {
        error "bug in the test script: not 3 or 4 parameters to test-expect-code"
        if ! test_skip "$@"
        then
-               say >&3 "expecting exit code $1: $3"
                test_run_ "$3"
                if [ "$?" = 0 -a "$eval_ret" = "$1" ]
                then
@@ -550,7 +619,6 @@ test_expect_code () {
                        test_failure_ "$@"
                fi
        fi
-       echo >&3 ""
 }
 
 # test_external runs external test scripts that provide continuous
@@ -596,7 +664,6 @@ test_external_without_stderr () {
        [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
        descr="no stderr: $1"
        shift
-       say >&3 "expecting no stderr from previous command"
        if [ ! -s "$stderr" ]; then
                rm "$stderr"
                test_ok_ "$descr"
@@ -684,34 +751,62 @@ test_done () {
        echo "failed $test_failure" >> $test_results_path
        echo "" >> $test_results_path
 
-       if test "$test_fixed" != 0
-       then
-               say_color pass "fixed $test_fixed known breakage(s)"
-       fi
-       if test "$test_broken" != 0
-       then
-               say_color error "still have $test_broken known breakage(s)"
-               msg="remaining $(($test_count-$test_broken)) test(s)"
+       echo
+
+       if [ "$test_failure" = "0" ]; then
+           rm -rf "$remove_tmp"
+           exit 0
        else
-               msg="$test_count test(s)"
+           exit 1
        fi
-       case "$test_failure" in
-       0)
-               say_color pass "passed all $msg"
-
-               test -d "$remove_trash" &&
-               cd "$(dirname "$remove_trash")" &&
-               rm -rf "$(basename "$remove_trash")"
+}
 
-               exit 0 ;;
+test_emacs () {
+       # Construct a little test script here for the benefit of the user,
+       # (who can easily run "run_emacs" to get the same emacs environment
+       # for investigating any failures).    
+       cat <<EOF > run_emacs
+#!/bin/sh
+export PATH=$PATH
+export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
 
-       *)
-               say_color error "failed $test_failure among $msg"
-               exit 1 ;;
+# We assume that the user will give a command-line argument only if
+# wanting to run in batch mode.
+if [ \$# -gt 0 ]; then
+       BATCH=--batch
+fi
 
-       esac
+# Here's what we are using here:
+#
+# --batch:             Quit after given commands and print all (messages)
+#
+# --no-init-file       Don't load users ~/.emacs
+#
+# --no-site-file       Don't load the site-wide startup stuff
+#
+# --directory          Ensure that the local notmuch.el source is found
+#
+# --load               Force loading of notmuch.el
+#
+# notmuch-test-wait    Function for tests to use to wait for process completion
+#
+# message-signature    Avoiding appending user's signature on messages
+#
+# set-frame-width      80 columns (avoids crazy 10-column default of --batch)
+
+emacs \$BATCH --no-init-file --no-site-file \
+       --directory ../../emacs --load notmuch.el \
+       --eval "(defun notmuch-test-wait ()
+                       (while (get-buffer-process (current-buffer))
+                               (sleep-for 0.1)))" \
+       --eval "(setq message-signature nil)" \
+       --eval "(progn (set-frame-width (window-frame (get-buffer-window)) 80) \$@)"
+EOF
+       chmod a+x ./run_emacs
+       ./run_emacs "$@"
 }
 
+
 find_notmuch_path ()
 {
     dir="$1"
@@ -732,7 +827,6 @@ find_notmuch_path ()
 # Test the binaries we have just built.  The tests are kept in
 # test/ subdirectory and are run in 'trash directory' subdirectory.
 TEST_DIRECTORY=$(pwd)
-# FIXME: Only the normal case bellow is updated to notmuch
 if test -n "$valgrind"
 then
        make_symlink () {
@@ -775,18 +869,15 @@ then
                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
        }
 
-       # override all git executables in TEST_DIRECTORY/..
+       # override notmuch executable in TEST_DIRECTORY/..
        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
        mkdir -p "$GIT_VALGRIND"/bin
-       for file in $TEST_DIRECTORY/../git* $TEST_DIRECTORY/../test-*
-       do
-               make_valgrind_symlink $file
-       done
+       make_valgrind_symlink $TEST_DIRECTORY/../notmuch
        OLDIFS=$IFS
        IFS=:
        for path in $PATH
        do
-               ls "$path"/git-* 2> /dev/null |
+               ls "$path"/notmuch 2> /dev/null |
                while read file
                do
                        make_valgrind_symlink "$file"
@@ -796,11 +887,6 @@ then
        PATH=$GIT_VALGRIND/bin:$PATH
        GIT_EXEC_PATH=$GIT_VALGRIND/bin
        export GIT_VALGRIND
-elif test -n "$GIT_TEST_INSTALLED" ; then
-       GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
-       error "Cannot run git from $GIT_TEST_INSTALLED."
-       PATH=$GIT_TEST_INSTALLED:$TEST_DIRECTORY/..:$PATH
-       GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
 else # normal case
        notmuch_path=`find_notmuch_path "$TEST_DIRECTORY"`
        test -n "$notmuch_path" && PATH="$notmuch_path:$PATH"
@@ -808,24 +894,24 @@ fi
 export PATH
 
 # Test repository
-test="trash directory.$(basename "$0" .sh)"
+test="tmp.$(basename "$0" .sh)"
 test -n "$root" && test="$root/$test"
 case "$test" in
-/*) TRASH_DIRECTORY="$test" ;;
- *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
+/*) TMP_DIRECTORY="$test" ;;
+ *) TMP_DIRECTORY="$TEST_DIRECTORY/$test" ;;
 esac
-test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
+test ! -z "$debug" || remove_tmp=$TMP_DIRECTORY
 rm -fr "$test" || {
        GIT_EXIT_OK=t
        echo >&5 "FATAL: Cannot prepare test area"
        exit 1
 }
 
-MAIL_DIR="${TRASH_DIRECTORY}/mail"
-export NOTMUCH_CONFIG="${TRASH_DIRECTORY}/notmuch-config"
+MAIL_DIR="${TMP_DIRECTORY}/mail"
+export NOTMUCH_CONFIG="${TMP_DIRECTORY}/notmuch-config"
 
 mkdir -p "${test}"
-mkdir "$MAIL_DIR"
+mkdir -p "${MAIL_DIR}"
 
 cat <<EOF >"${NOTMUCH_CONFIG}"
 [database]
@@ -842,12 +928,18 @@ EOF
 # in subprocesses like git equals our $PWD (for pathname comparisons).
 cd -P "$test" || error "Cannot setup test environment"
 
+if test "$verbose" = "t"
+then
+       exec 4>&2 3>&1
+else
+       exec 4>test.output 3>&4
+fi
+
 this_test=${0##*/}
-this_test=${this_test%%-*}
-for skp in $GIT_SKIP_TESTS
+for skp in $NOTMUCH_SKIP_TESTS
 do
        to_skip=
-       for skp in $GIT_SKIP_TESTS
+       for skp in $NOTMUCH_SKIP_TESTS
        do
                case "$this_test" in
                $skp)